superstrict
Import brl.linkedlist

' Get a list of factor pairs as arrays of longs
Function FactorPairs:TList(n%%) 'return all positive factor pairs
	n=Abs(n)
	Local ret:TList=CreateList()
	For Local x%%=1 To n
		If n Mod x=0
			local v%%[] = [x, n/x]
			ret.addlast v
		endif
	Next
	Return ret
End Function

' Get all prime factors
Function PrimeFactors:TList(n%%)
	Local ret:TList=CreateList()
	Local x%%=2
	Repeat
		If n Mod x=0 Then
			local v%%[] = [x]
			ret.addlast v
			n:/x
			Continue
		endif
		x:+2;If x=4 x=3
		If n=1 Then Exit
	Forever
	Return ret
End Function

' Get factor pair with the least difference between the factors
function SquareFactorPair%%[](n%%)
	local pairs:tlist=factorpairs(n)
	local best%%[]=null
	local bestmag%%
	for local p%%[]=eachin pairs
		local mag%%=abs(p[1]-p[0])
		if best=null or mag<bestmag
			best=p
			bestmag=mag
		endif
	next
	return best
end function

' Get factor pairs as a string
function FactorPairsString$(n%%)
	local l:tlist=factorpairs(n)
	local ret$=""
	For Local v%%[]=EachIn l
		ret:+v[0]+","+v[1]+"~n"
	Next
	Return ret
end function

' Get prime factors as a string
Function FactorsString$(n%%)
	Local l:TList=primefactors(n)
	Local ret$=""
	For Local v%%[]=EachIn l
		ret:+v[0]+"~n"
	Next
	Return ret
End Function

