SuperStrict

Type functionqueue
	Field front:fqueuenode
	Method enqueue:fqueuenode(data())
		Local n:fqueuenode=fqueuenode.Create(data)
		If front lastnode().nxt=n Else front=n
		Return n
	End Method
	Method lastnode:fqueuenode()
		Local on:fqueuenode=front
		While on
			If on.nxt on=on.nxt Else Return on
		Wend
		Return Null
	End Method
	Method last()()
		Return lastnode().data
	End Method
	Method dequeuenode:fqueuenode()
		Local r:fqueuenode=front
		front=front.nxt
		Return r
	End Method
	Method dequeue()()
		Return dequeuenode().data
	End Method
	Method peeknode:fqueuenode()
		Return front
	End Method
	Method peek()()
		Return peeknode().data
	End Method
	Method count%()
		Local i%=0,on:fqueuenode=front
		While on
			i:+1;on=on.nxt
		Wend
		Return i
	End Method
	Method isempty%()
		If front Return 0
		Return 1
	End Method
	Function Create:functionqueue()
		Return New functionqueue
	End Function
End Type
Type fqueuenode
	Field data()
	Field nxt:fqueuenode
	Function Create:fqueuenode(data())
		Local n:fqueuenode=New fqueuenode
		n.data=data
		Return n
	End Function
End Type


